/*******************************************************
 *  _____                                              *
 * |  ___|  __    __   _  __  _   __   __   ____       *
 * | |___  |  \  /  | | ||  || | \  \/  /  |__  \      *
 * |___  | |   \/   | | \/  \/ |  \    /      | |      *
 *  ___| | | /\  /\ | |   /\   |  /    \    _/ /_      *
 * |_____| |_||__||_| |__/  \__| /__/\__\  |_____|     *
 *                                                     *
 *******************************************************
 *     (c) Gaming Brasil - 2004                        *
 *     Made by Alexandre Martins (@leX)                *
 *     http://www.gamingbrasil.net                     *
 *******************************************************/
 
 #ifndef _DATA_H
 #define _DATA_H

 // header files
 #include <allegro.h>
 #include <fmod.h>
 #include <alfont.h>
 #include <vector>
 #include <string>
 #include <iostream>
 #include "Game.h"
 #include "Timers.h"
 #include "Sprite.h"
 #include "Utils.h"
 #include "Ini.h"
 using namespace std;
 
 // constants
 // Fonts - each font has 3 slots.
 #define ARIAL1							0	// Arial - Slot 1
 #define ARIAL2							1	// Arial - Slot 2
 #define ARIAL3							2	// Arial - Slot 3
 #define _ARIAL4						3	// DO NOT USE! For -- Debug ("./debugmode") -- only -> Arial - Special Slot 4
 #define _ARIAL5						4	// DO NOT USE! For -- Quit message -- only -> Arial - Special Slot 4
 #define _ARIAL6						5	// DO NOT USE! Level Editor special slot
 #define _ARIAL7						6	// DO NOT USE! Level Editor special slot
 #define _ARIAL8						7	// DO NOT USE! Level Editor special slot
 #define _ARIAL9						8   // Available for use!
 #define ARIALB1						9	// Arial Bold - Slot 1
 #define ARIALB2						10	// Arial Bold - Slot 2
 #define ARIALB3						11	// Arial Bold - Slot 3
 #define COMICSANS1						12	// ComicSans - Slot 1
 #define COMICSANS2						13	// ComicSans - Slot 2
 #define COMICSANS3						14	// ComicSans - Slot 3
 #define MAILRAYS1						15	// MailRays - Slot 1
 #define MAILRAYS2						16	// MailRays - Slot 2
 #define MAILRAYS3						17	// MailRays - Slot 3
 
 // Other classes
 class CIni;
 class Game;
 class CAnimation;
 class CPlayer;
 class CEnemy;
 class CItem;
 
 // Language class
 class CLanguage{
 public:
	 string				language;
	 CIni				pdata;
	 void				ReadFile(const string& sFile);
	 
	 CLanguage(){}
	 CLanguage(const string& sFile){ ReadFile(sFile); }
 };
 
 // Data
 class Data{
 public:
	 
	 static vector<string>				sImage;
	 static vector<string>				sAnimation;
	 static vector<string>				sSuperBgAnimation;
	 static vector<string>				sBgAnimation;
	 static vector<string>				sFgAnimation;
	 static vector<string>				sEnemy;
	 static vector<string>				sItem;
	 static vector<string>				sSample;
	 static vector<string>				sMusic;
	 static vector<string>				sFont;
	 
	 static vector<BITMAP*>				image;
	 static vector<CAnimation>			animation; // for sprites
	 static vector<CAnimation>			superBgAnimation; // for super bgs
	 static vector<CAnimation>			bgAnimation; // for bgs
	 static vector<CAnimation>			fgAnimation; // for foregrounds
	 static vector<CEnemy>				enemy;
	 static vector<CItem>				item;
	 static vector<SAMPLE*>				sample;
	 static vector<FMUSIC_MODULE*>		music;
	 static vector<ALFONT_FONT*>		font;
	 static vector<CLanguage>			lang;
	 static vector<CPlayer>				character;
	 static vector<CAnimation>			mapTile;
	 
	 static void						ReadLists();
	 static void						loadImages();
	 static void						loadAnimations();
	 static void						loadBgAnimations();
	 static void						loadEnemies();
	 static void						loadItems();
	 static void						loadSamples();
	 static void						loadMusics();
	 static void						loadLanguages();
	 static void						loadFonts();
	 static void						loadCharacters();
	 static void						loadMapTiles();
	 static void						loadAll();
	 static void						releaseImages();
	 static void						releaseAnimations();
	 static void						releaseBgAnimations();
	 static void						releaseEnemies();
	 static void						releaseItems();
	 static void						releaseSamples();
	 static void						releaseMusics();
	 static void						releaseFonts();
	 static void						releaseCharacters();
	 static void						releaseMapTiles();
	 static void						releaseAll();
	 
	 static string						Lang(string x);
 };
 
 #endif
