/*******************************************************
 *  _____                                              *
 * |  ___|  __    __   _  __  _   __   __   ____       *
 * | |___  |  \  /  | | ||  || | \  \/  /  |__  \      *
 * |___  | |   \/   | | \/  \/ |  \    /      | |      *
 *  ___| | | /\  /\ | |   /\   |  /    \    _/ /_      *
 * |_____| |_||__||_| |__/  \__| /__/\__\  |_____|     *
 *                                                     *
 *******************************************************
 *     (c) Gaming Brasil - 2004                        *
 *     Made by Alexandre Martins (@leX)                *
 *     http://www.gamingbrasil.net                     *
 *******************************************************/
 
 #include "FadeFX.h"
 
 // -----------------------------------------------------
 // fadeIn(bmp_orig, speed): the common fade-in routine
 // -----------------------------------------------------
 void FadeFX::fadeIn(BITMAP *bmp_orig, int speed){
	 
	 BITMAP *bmp_buff;
     int a;
	 
     if(speed <= 0)
		 speed = 16;
	 
	 if((bmp_buff = create_bitmap(BUFFER_W, BUFFER_H))){
		 clear_bitmap(bmp_buff);
		 blit(bmp_orig, bmp_buff, 0, 0, 0, 0, bmp_orig->w, bmp_orig->h);
		 for(a=0; a<256; a+=speed){
			 clear_bitmap(Game::bmpBuffer);
			 draw_trans(bmp_buff, Game::bmpBuffer, 0, 0, a);
			 vsync();
			 vsync();
			 Game::events();
			 Game::render();
		 }
		 blit(bmp_orig, Game::bmpBuffer, 0,0, 0,0, bmp_orig->w, bmp_orig->h);
		 Game::events();
		 Game::render();
		 destroy_bitmap(bmp_buff);
	 }
 }
 
 // -----------------------------------------------------
 // fadeOut(color, speed): the common fade-out routine
 // -----------------------------------------------------
 void FadeFX::fadeOut(int color, int speed){
	 
    BITMAP *bmp_orig;
	int a;

	if(speed <= 0)
		speed = 16;
	
	if((bmp_orig = create_bitmap(BUFFER_W, BUFFER_H))){
		blit(Game::bmpBuffer, bmp_orig, 0,0, 0,0, BUFFER_W, BUFFER_H);
		for(a=0;a<256;a+=speed){
			blit(bmp_orig, Game::bmpBuffer,0, 0, 0, 0, BUFFER_W, BUFFER_H);
			rect_trans(Game::bmpBuffer, 0, 0, BUFFER_W, BUFFER_H, color, a);
			vsync();
			vsync();
			Game::events();
			Game::render();
		}
		destroy_bitmap(bmp_orig);
	}
	
    clear_to_color(Game::bmpBuffer, color);
	Game::events();
	Game::render();
 }
