/*******************************************************
 *  _____                                              *
 * |  ___|  __    __   _  __  _   __   __   ____       *
 * | |___  |  \  /  | | ||  || | \  \/  /  |__  \      *
 * |___  | |   \/   | | \/  \/ |  \    /      | |      *
 *  ___| | | /\  /\ | |   /\   |  /    \    _/ /_      *
 * |_____| |_||__||_| |__/  \__| /__/\__\  |_____|     *
 *                                                     *
 *******************************************************
 *     (c) Gaming Brasil - 2004                        *
 *     Made by Alexandre Martins (@leX)                *
 *     http://www.gamingbrasil.net                     *
 *******************************************************/
 
 #include "Frames.h"

 
 // --------------------------------------------
 // language_selector(): Select your language
 // --------------------------------------------
 void Frame::language_selector(){
	 
	 CIni ini;
	 CSprite star(&Data::animation[0]);
	 bool ev[2];
	 bool quit = false;
	 int a, option = 0;
	 
	 text_mode(-1);
	 while(!quit){
		 while(Game::MayRun()){
			 
			 // background
			 blit(Data::image[2], Game::bmpBuffer, 0, 0, 0, 0, Data::image[2]->w, Data::image[2]->h);
			 
			 // option
			 if(!Player1_Control.is_up()) ev[0] = false;
			 if(Player1_Control.is_up() && !ev[0]){ ev[0] = true; option--; play_sample(Data::sample[1]); }
			 if(!Player1_Control.is_down()) ev[1] = false;
			 if(Player1_Control.is_down() && !ev[1]){ ev[1] = true; option++; play_sample(Data::sample[1]); }
			 if(option < 0) option = int(Data::lang.size()) - 1;
			 if(option >= int(Data::lang.size())) option = 0;
			 
			 // draw options
			 for(a=0;a<int(Data::lang.size());a++){
				 textprintf(Game::bmpBuffer, font, 64, 64 + (a*text_height(font) + (a != 0 ? 20*a : 0)), makecol(135,135,135), Data::lang[a].language.c_str());
				 textprintf(Game::bmpBuffer, font, 65, 65 + (a*text_height(font) + (a != 0 ? 20*a : 0)), makecol(215,215,215), Data::lang[a].language.c_str());
			 }
			 
			 // star
			 star.RunAnimation();
			 star.x = 40;
			 star.y = 61 + (option*text_height(font) + (option != 0 ? 20*option : 0));
			 star.draw(Game::bmpBuffer);
			 
			 // language selected!
			 if(Player1_Control.is_start() || Player1_Control.is_fire1()){
				 Game::iLanguage = option;
				 play_sample(Data::sample[2]);
				 
				 if(ini.ReadFile("./data/smwx2.ini"))
					 ini.WriteInt("language", Game::iLanguage);
				 
				 quit = true;
			 }
			 
			 // events
			 Game::events();
		 }
		 Game::render();
	 }
	 
	 FadeFX::fadeOut(0, 16);
	 
 }
 
 
 
 // --------------------------------------------
 // presentation(): Gaming Brasil, etc.
 // --------------------------------------------
 void Frame::presentation(){
	 
	 Game::logfile("Presentation");
	 
	 // -- GamingBrasil --
	 ALFONT_FONT **gbfnt = &Data::font[ARIAL1];
	 BITMAP *gbScreen = create_bitmap(Data::image[3]->w, Data::image[3]->h);
	 blit(Data::image[3], gbScreen, 0, 0, 0, 0, gbScreen->w, gbScreen->h);
	 alfont_set_font_size(*gbfnt, 20);
	 alfont_textout_centre_aa_ex(gbScreen, *gbfnt, "http://www.gamingbrasil.net", BUFFER_W/2, 190, makecol(190,190,190), -1);
	 
	 FadeFX::fadeOut(0, 16);
	 FadeFX::fadeIn(gbScreen, 16);
	 GSleep(4000);
	 FadeFX::fadeOut(0, 16);
	 
	 destroy_bitmap(gbScreen);
	 
	 // -- Game made by Alexandre Martins (@leX) --
	 // preparing bitmap...
	 ALFONT_FONT **fnt = &Data::font[ARIALB1];
	 BITMAP *madeby = create_bitmap(BUFFER_W, BUFFER_H);
	 clear_bitmap(madeby);
	 
	 alfont_set_font_size(*fnt, 26);
	 alfont_textout_centre_aa_ex(madeby, *fnt, Data::Lang("madeby").c_str(), BUFFER_W/2, 50, makecol(255,255,255), -1);
	 alfont_textout_centre_aa_ex(madeby, *fnt, "Alexandre Martins (@leX)", BUFFER_W/2, 60 + alfont_text_height(*fnt), makecol(255,255,255), -1);
	 alfont_set_font_size(*fnt, 16);
	 alfont_textout_right_aa_ex(madeby, *fnt, "2004", BUFFER_W - 10, BUFFER_H - alfont_text_height(*fnt) - 2, makecol(225,225,225), -1);
	 CPlayer::getChar("Super Mario")->x = 10;
	 CPlayer::getChar("Super Mario")->y = BUFFER_H - CPlayer::getChar("Super Mario")->height() - 10;
	 CPlayer::getChar("Super Mario")->ChangeAnimation(ANIM_JUMP);
	 CPlayer::getChar("Super Mario")->RunAnimation();
	 CPlayer::getChar("Super Mario")->draw(madeby);
	 
	 // showing
	 FadeFX::fadeIn(madeby, 16);
	 play_sample(Data::sample[0]);
	 GSleep(4000);
	 FadeFX::fadeOut(0, 16);
	 
	 // destroying bitmap
	 destroy_bitmap(madeby);
 }

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 // --------------------------------------------
 // main_menu(): Main menu
 // --------------------------------------------
 // main_menu vars
 BITMAP *main_menu_smwx2logo, *main_menu_menulayer, *main_menu_background;
 CSprite main_menu_koopa[3], main_menu_star, main_menu_waterfall;
 ALFONT_FONT **main_menu_fnt_menu, **main_menu_fnt_credits, **op_menu_fnt;
 
 // main_menu_start()
 static void main_menu_start(){
	 int a, theEnemy;
	 
	 Game::logfile("Main Menu -> start");
	 
	 main_menu_smwx2logo = Data::image[7];
	 main_menu_menulayer = Data::image[5];
	 main_menu_background = Data::image[6];
	 
	 for(a=0;a<3;a++){
		 theEnemy = int(rand()%3);
		 main_menu_koopa[a].anim = &Data::enemy[theEnemy];
		 main_menu_koopa[a].interval[0] = Data::enemy[theEnemy].animInterval[0][EANIM_WALK];
		 main_menu_koopa[a].interval[1] = Data::enemy[theEnemy].animInterval[1][EANIM_WALK];
		 main_menu_koopa[a].x = -(a * (40 + 10));
		 main_menu_koopa[a].y = 209 - main_menu_koopa[a].height();
		 main_menu_koopa[a].alterableValue[0] = ((rand()%2)==0) ? 0.5 : 0.25;
	 }
	 
	 main_menu_star.SetAnimPointer(&Data::animation[0]);
	 main_menu_waterfall.SetAnimPointer(&Data::bgAnimation[0]);
	 main_menu_waterfall.y = 123;//143;
	 
	 main_menu_fnt_menu = &Data::font[ARIAL1];
	 alfont_set_font_size(*main_menu_fnt_menu, 16);
	 main_menu_fnt_credits = &Data::font[ARIAL2];
	 alfont_set_font_size(*main_menu_fnt_credits, 14);
	 op_menu_fnt = &Data::font[ARIAL3];
	 alfont_set_font_size(*op_menu_fnt, 14);
	 
	 FMUSIC_PlaySong(Data::music[0]);
 }
 
 // main_menu_end()
 static void main_menu_end(){
	 Game::logfile("Main Menu -> end");
 }
 
 // main_menu_quit(): Really quit?
 static bool main_menu_quit(){
	 
	 BITMAP *bmp;
	 string msg;
	 CSprite star(&Data::animation[0]);
	 bool returnvalue = false, quit = false;
	 int option = 0,
		 x = BUFFER_W/2 - Data::image[10]->w/2,
		 y = BUFFER_H/2 - Data::image[10]->h/2;
		 
	 Game::logfile("Main Menu -> Really quit?");
		 
	 star.x = x+10;
	 msg = Data::Lang("quit_msg0") +
		"\n        " +
		Data::Lang("yes") +
		"\n        " +
		Data::Lang("no") +
		"\n#ylw - " +
		Data::Lang("quit_msg"+StringUtils::int2str( int((rand()%4)+1) ));
		
	 bmp = create_bitmap(BUFFER_W, BUFFER_H);
	 blit(Game::bmpBuffer, bmp, 0, 0, 0, 0, BUFFER_W, BUFFER_H);
	 
	 rect_trans(bmp, x, y, Data::image[10]->w, Data::image[10]->h, 0, 125);
	 draw_sprite(bmp, Data::image[10], x, y);
	 alfont_set_font_size(Data::font[_ARIAL5], 13);
	 alfont_textprintf_color(bmp, Data::font[_ARIAL5], x+6, y+6, -1, 28, msg.c_str());
	 
	 while(!quit){
		 while(Game::MayRun()){
			 blit(bmp, Game::bmpBuffer, 0, 0, 0, 0, BUFFER_W, BUFFER_H);
			 
			 // <star>
			 star.y = y+5 + alfont_text_height(Data::font[_ARIAL5])*(option+1);
			 star.RunAnimation();
			 star.draw(Game::bmpBuffer);
			 // </star>
			 
			 // <option>
			 if(Player1_Control.keypress(K_UP)){ option--; play_sample(Data::sample[1]); }
			 if(Player1_Control.keypress(K_DOWN)){ option++; play_sample(Data::sample[1]); }
			 if(option < 0) option = 1;
			 if(option > 1) option = 0;
			 if(Player1_Control.keypress(K_FIRE1) || Player1_Control.keypress(K_START)){
				 returnvalue = (option == 0) ? true : false;
				 quit = true;
				 play_sample(Data::sample[2]);
				 
				 if(returnvalue)
					 FadeFX::fadeOut(0,16);
			 }
			 // </option>
			 
			 Game::events();
		 }
		 
		 if(!quit)
			 Game::render();
	 }
	 
	 destroy_bitmap(bmp);
	 return returnvalue;
	 
 }
 
 // main_menu_DefineKeys(p1_joy, p2_joy)
 static void main_menu_DefineKeys(bool p1_joy, bool p2_joy){
	 
	 int a, kPress[2][7];
	 string kPressStr[7] = { "keyb_start", "keyb_left", "keyb_right", "keyb_up", "keyb_down", "keyb_fire1", "keyb_fire2" };
	 
	 rect_trans(Game::bmpBuffer, 0, 0, BUFFER_W, BUFFER_H, 0, 150);
	 alfont_set_font_size(*op_menu_fnt, 13);
	 
	 alfont_textprintf_color(
		 /* bmp, font          */ Game::bmpBuffer, *op_menu_fnt,
		 /* xpos               */ BUFFER_W - (alfont_text_length(*op_menu_fnt, "Define keys...")) - 10,
		 /* ypos, bg, wordwrap */ BUFFER_H - alfont_text_height(*op_menu_fnt) - 5, -1, 0,
		 /* string             */ "#ylwDefine keys..."
	 );
	 
	 GSleep(1000);
	 
	 // <Player 1>
	 alfont_textprintf_color(Game::bmpBuffer, *op_menu_fnt, 7, 2 + alfont_text_height(*op_menu_fnt)*0, -1, 0,"$E4FA6A- Player 1 -");
	 if(!p1_joy){
		 for(a=0;a<7;a++){
			 alfont_textprintf_color(Game::bmpBuffer, *op_menu_fnt, 7, 2 + alfont_text_height(*op_menu_fnt)*(a+1), -1, 0,"[press] New key for %s", Data::Lang(kPressStr[a]).c_str());
			 Game::render();
			 clear_keybuf();
			 kPress[0][a] = (readkey() >> 8);
			 Timer::fix_speedcounter();
			 play_sample(Data::sample[3]);
		 }
	 }else{
		 alfont_textprintf_color(Game::bmpBuffer, *op_menu_fnt, 7, 2 + alfont_text_height(*op_menu_fnt)*1, -1, 0,"#red%s", Data::Lang("joyerr1").c_str());
		 Game::render();
		 clear_keybuf(); readkey();
		 play_sample(Data::sample[3]);
	 }
	 // </Player 1>
	 
	 // <Player 2>
	 alfont_textprintf_color(Game::bmpBuffer, *op_menu_fnt, 7, 2 + alfont_text_height(*op_menu_fnt)*9, -1, 0,"$6ADAFA- Player 2 -");
	 if(!p2_joy){
		 for(a=0;a<7;a++){
			 alfont_textprintf_color(Game::bmpBuffer, *op_menu_fnt, 7, 2 + alfont_text_height(*op_menu_fnt)*(a+10), -1, 0,"[press] New key for %s", Data::Lang(kPressStr[a]).c_str());
			 Game::render();
			 clear_keybuf();
			 kPress[1][a] = (readkey() >> 8);
			 Timer::fix_speedcounter();
			 play_sample(Data::sample[3]);
		 }
	 }else{
		 alfont_textprintf_color(Game::bmpBuffer, *op_menu_fnt, 7, 2 + alfont_text_height(*op_menu_fnt)*10, -1, 0,"#red%s", Data::Lang("joyerr1").c_str());
		 Game::render();
		 clear_keybuf(); readkey();
		 play_sample(Data::sample[3]);
	 }
	 // </Player 2>
	 
	 // Done!
	 if(!p1_joy) Player1_Control.set_keys(kPress[0][0], kPress[0][1], kPress[0][2], kPress[0][3], kPress[0][4], kPress[0][5], kPress[0][6]);
	 if(!p2_joy) Player2_Control.set_keys(kPress[1][0], kPress[1][1], kPress[1][2], kPress[1][3], kPress[1][4], kPress[1][5], kPress[1][6]);
	 alfont_set_font_size(*op_menu_fnt, 14);
	 play_sample(Data::sample[4]);
	 rest(2000);
	 Timer::fix_speedcounter();
	 
 }
 
 // main_menu_options(): Options
 static void main_menu_options(){
	 
	 CSprite star(&Data::animation[0]);
	 CIni Ini("./data/smwx2.ini");
	 string op_renderengineStr[4]; // Normal, Normal (2x), 2xSaI, SuperEagle
	 static bool enableDefKeys = exists("./defkeys") ? true : false;
	 bool quit = false, changedGfx = false, p1_usejoy = Player1_Control.bUseJoystick, p2_usejoy = Player2_Control.bUseJoystick, oldp1_usejoy = false, oldp2_usejoy = false;
	 float bgy = 0.0f;
	 int option = 0,
		 optioncount = 8,
		 w = 260, h = 175 ,
		 x = BUFFER_W/2 - w/2,
		 y = BUFFER_H/2 - h/2,
		 op_screenwidth = Game::iRealScreenWidth,
		 op_screenheight = Game::iRealScreenHeight,
		 op_renderengine = Game::gfx_iRenderEngine + 1;
	 
	 Game::logfile("Main Menu -> Options");
		 
	 while(!quit){
		 while(Game::MayRun()){
			 
			 // <op_renderengineStr>
			 op_renderengineStr[0] = "Normal ("+Data::Lang("fast")+")";
			 op_renderengineStr[1] = "Normal (2x)";
			 op_renderengineStr[2] = "2xSaI ("+Data::Lang("nicelooking")+")";
			 op_renderengineStr[3] = "SuperEagle ("+Data::Lang("nicelooking")+")";
			 // </op_renderengineStr>
			 
			 // <background>
			 blit(Data::image[8], Game::bmpBuffer, 0, 0, 0, int(bgy), Data::image[8]->w, Data::image[8]->h);
			 blit(Data::image[8], Game::bmpBuffer, 0, 0, 0, int(bgy)+Data::image[8]->h, Data::image[8]->w, Data::image[8]->h);
			 bgy -= 0.25f;
			 if(bgy <= -Data::image[8]->h) bgy = 0.0f;
			 rect_trans(Game::bmpBuffer, x, y, w, h, 0, 100);
			 // </background>
			 
			 // <menu>
			 if(Player1_Control.keypress(K_UP) && option > 0){ option--; play_sample(Data::sample[1]); }
			 if(Player1_Control.keypress(K_DOWN) && option < optioncount-1){ option++; play_sample(Data::sample[1]); }
			 alfont_textprintf_color(Game::bmpBuffer, *op_menu_fnt, x+5+star.width(), y+2, -1, 0,
			 
				 "%s\n" 				// - Game config -
				 "%s #ylw%s#wht\n"		// Language: [str]
				 "%s #ylw%s#wht\n"		// Input Device (P1): [str]
				 "%s #ylw%s#wht\n"		// Input Device (P2): [str]
				 "%s\n\n"				// Level Editor
				 "%s\n"					// - Video config -
				 "%s #ylw%d x %d#wht\n"	// ScreenSize: [int]x[int]
				 "%s #ylw%s#wht\n"		// RenderEngine: [str]
				 "%s #ylw%s#wht\n\n"	// Fullscreen: [str]
				 "%s",					// Done!
				 
				 Data::Lang("opmenu_f0str0").c_str(),
				 Data::Lang("opmenu_f0str1").c_str(), Data::lang[Game::iLanguage].language.c_str(),
				 Data::Lang("opmenu_f0str2").c_str(), Data::Lang(p1_usejoy ? "joystick" : "keyboard").c_str(),
				 Data::Lang("opmenu_f0str3").c_str(), Data::Lang(p2_usejoy ? "joystick" : "keyboard").c_str(),
				 Data::Lang("opmenu_f0str4").c_str(),
				 Data::Lang("opmenu_f1str0").c_str(),
				 Data::Lang("opmenu_f1str1").c_str(), op_screenwidth, op_screenheight,
				 Data::Lang("opmenu_f1str2").c_str(), op_renderengineStr[op_renderengine].c_str(),
				 Data::Lang("opmenu_f1str3").c_str(), Data::Lang(Game::gfx_bFullscreen ? "yes" : "no").c_str(),
				 Data::Lang("opmenu_done").c_str()
				 
			 );
			 // </menu>
			 
			 // <star>
			 // calculating position...
			 star.x = x + 2;
			 star.y = y + 2;
			 switch(option){
			 case 0: star.y += alfont_text_height(*op_menu_fnt)*1; break;
			 case 1: star.y += alfont_text_height(*op_menu_fnt)*2; break;
			 case 2: star.y += alfont_text_height(*op_menu_fnt)*3; break;
			 case 3: star.y += alfont_text_height(*op_menu_fnt)*4; break;
			 case 4: star.y += alfont_text_height(*op_menu_fnt)*7; break;
			 case 5: star.y += alfont_text_height(*op_menu_fnt)*8; break;
			 case 6: star.y += alfont_text_height(*op_menu_fnt)*9; break;
			 case 7: star.y += alfont_text_height(*op_menu_fnt)*11; break;
			 }
			 
			 // star stuff
			 star.RunAnimation();
			 star.draw(Game::bmpBuffer);
			 // </star>
			 
			 // <menu_options>
			 // Options
			 if(Player1_Control.keypress(K_START) || Player1_Control.keypress(K_FIRE1)){
				 play_sample(Data::sample[  (option != optioncount-1) ? 3 : 2  ]);
				 switch(option){
				 /* Language          */ case 0: Game::iLanguage++; break;
				 /* Input Device (P1) */ case 1: p1_usejoy = !p1_usejoy; break;
				 /* Input Device (P2) */ case 2: p2_usejoy = !p2_usejoy; break;
				 /* Level Editor      */ case 3: FMUSIC_StopSong(Data::music[0]); FadeFX::fadeOut(0,32); Frame::level_editor(); FMUSIC_PlaySong(Data::music[0]); break;
				 /* Screen Size       */ case 4: op_screenwidth = (op_screenwidth==320)?640:320; op_screenheight = (op_screenheight==240)?480:240; changedGfx = true; break;
				 /* Render Engine     */ case 5: op_renderengine++; changedGfx = true; break;
				 /* Fullscreen        */ case 6: Game::gfx_bFullscreen = !Game::gfx_bFullscreen; changedGfx = true; break;
				 /* Done!             */ case 7: quit = true; FadeFX::fadeOut(0, 16); break;
				 }
			 }
			 
			 // defkeys?
			 if(enableDefKeys){
				 if(key[KEY_D])
					 main_menu_DefineKeys(p1_usejoy, p2_usejoy);
			 }
			 
			 // Language fix
			 if(Game::iLanguage >= int(Data::lang.size()))
				 Game::iLanguage = 0;
			 
			 // RenderEngine fix
			 if(op_screenwidth == 320){ //320x240?
				 op_renderengine = 0; // Force Normal mode
			 }else{ //640x480?
				 // Normal goes to Normal (2x)
				 if(op_renderengine == 0)
					 op_renderengine = 1;
				 
				 // bugfix?
				 if(op_renderengine > 3)
					 op_renderengine = 1;
			 }
			 
			 // joystick stuff
			 if(p1_usejoy && oldp1_usejoy && p2_usejoy && !oldp2_usejoy){
				 p1_usejoy = false;
				 p2_usejoy = true;
			 }
			 if(p1_usejoy && !oldp1_usejoy && p2_usejoy && oldp2_usejoy){
				 p1_usejoy = true;
				 p2_usejoy = false;
			 }
			 oldp1_usejoy = p1_usejoy;
			 oldp2_usejoy = p2_usejoy;
			 
			 // </menu_options>
			 
			 Game::events();
		 }
		 if(!quit)
			 Game::render();
	 }
	 
	 // GENERAL: updating some joystick-related stuff
	 if(!p1_usejoy && !p2_usejoy)
		 remove_joystick();
	 else{
		 if(install_joystick(JOY_TYPE_AUTODETECT) != 0){
			 SMAlert("#red" + Data::Lang("error") + ": #wht" + Data::Lang("joyerr3") + "\n----------------------------------------\n" + Data::Lang("logfile"));
			 Game::logfile("Couldn't install joystick: %s",allegro_error);
			 p1_usejoy = false;
			 p2_usejoy = false;
		 }
	 }
	 
	 if( (p1_usejoy || p2_usejoy) && !CInputDevice::isJoystickAvailable() ){
		 SMAlert("#red" + Data::Lang("error") + ": #wht" + Data::Lang("joyerr0") + "\n----------------------------------------\n" + Data::Lang("joyerr2"));
		 p1_usejoy = false;
		 p2_usejoy = false;
	 }
	 Player1_Control.bUseJoystick = p1_usejoy;
	 Player2_Control.bUseJoystick = p2_usejoy;
	 
	 // GENERAL: updating the "smwx2.ini" file
	 Ini.WriteInt("language", Game::iLanguage);
	 
	 // Change the graphic mode if necessary
	 bool old_fullscreen = Game::gfx_bFullscreen;
	 int old_renderengine = Game::gfx_iRenderEngine;
	 int old_rendertype = Game::gfx_iRenderType;
	 
	 // updating gfx
	 if(changedGfx){
		 set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		 Game::gfx_iRenderEngine =(op_screenwidth==320) ? 0 : op_renderengine-1;
		 Game::gfx_iRenderType = (op_screenwidth==320) ? RENDERTYPE_NORMAL : RENDERTYPE_DOUBLESIZED;
		 Ini.WriteInt("fullscreen", Game::gfx_bFullscreen ? 1 : 0);
		 Ini.WriteInt("renderengine", Game::gfx_iRenderEngine);
		 Ini.WriteInt("rendertype", Game::gfx_iRenderType);
		 if(Game::start_gfx() != 0){
			 Ini.WriteInt("fullscreen", old_fullscreen ? 1 : 0);
			 Ini.WriteInt("renderengine", old_renderengine);
			 Ini.WriteInt("rendertype", old_rendertype);
			 Game::logfile("Couldn't set the graphic mode. Please restart the game.\n%s", allegro_error);
			 MsgBox("Cannot set the graphic mode. Please restart the game.\n%s", allegro_error);
			 Game::abort();
		 }
		 Timer::fix_speedcounter();
	 }
	 
 }
 
 // main_menu()
 void Frame::main_menu(){
	 
	 bool quit = false;
	 int a;
	 int option = 0;
	 main_menu_start();
	 
	 Game::logfile("Main Menu");
	 
	 // <Menu>
	 while(!quit){
		 while(Game::MayRun()){
			 
			 // background
			 blit(main_menu_background, Game::bmpBuffer, 0, 0, 0, 0, main_menu_background->w, main_menu_background->h);
			 main_menu_waterfall.RunAnimation();
			 main_menu_waterfall.draw(Game::bmpBuffer);
			 draw_sprite(Game::bmpBuffer, main_menu_smwx2logo, BUFFER_W/2 - main_menu_smwx2logo->w/2, 0);
			 
			 // koopas (var a: horizontal speed)
			 for(a=0;a<3;a++){
				 main_menu_koopa[a].RunAnimation();
				 main_menu_koopa[a].draw(Game::bmpBuffer);
				 main_menu_koopa[a].x += main_menu_koopa[a].alterableValue[0];
				 
				 if(
				 (main_menu_koopa[a].x >= BUFFER_W && main_menu_koopa[a].alterableValue[0] > 0) ||
				 (main_menu_koopa[a].x <= -main_menu_koopa[a].width() && main_menu_koopa[a].alterableValue[0] < 0)
				 ){
					 main_menu_koopa[a].anim = &Data::enemy[rand()%3];
					 main_menu_koopa[a].interval[0] = Data::enemy[rand()%3].animInterval[0][EANIM_WALK];
					 main_menu_koopa[a].interval[1] = Data::enemy[rand()%3].animInterval[1][EANIM_WALK];
					 main_menu_koopa[a].y = 209 - main_menu_koopa[a].height();
					 
					 main_menu_koopa[a].alterableValue[0] = 0;
					 while(main_menu_koopa[a].alterableValue[0] == 0){
						 main_menu_koopa[a].alterableValue[0] = ((rand()%2) == 0) ? (rand()%2)-0.5 : ((rand()%2)-0.5)/2;
						 if(main_menu_koopa[a].alterableValue[0] > 0){
							 main_menu_koopa[a].x = -main_menu_koopa[a].width();
							 if(main_menu_koopa[a].hflipped()) main_menu_koopa[a].hflip();
						 }
						 if(main_menu_koopa[a].alterableValue[0] < 0){
							 main_menu_koopa[a].x = BUFFER_W+main_menu_koopa[a].width();
							 if(!main_menu_koopa[a].hflipped()) main_menu_koopa[a].hflip();
						 }
					 }
				 }
			 }
			 
			 // menulayer
			 draw_sprite(Game::bmpBuffer, main_menu_menulayer, 0, BUFFER_H-main_menu_menulayer->h);
			 
			 // credits
			 alfont_textout_aa_ex(Game::bmpBuffer, *main_menu_fnt_credits, Data::Lang("madeby").c_str(), 2, BUFFER_H - alfont_text_height(*main_menu_fnt_credits)*2, makecol(255,255,255), -1);
			 alfont_textout_aa_ex(Game::bmpBuffer, *main_menu_fnt_credits, "Alexandre Martins (@leX)", 2, BUFFER_H - alfont_text_height(*main_menu_fnt_credits), makecol(255,255,255), -1);
			 alfont_textout_right_aa_ex(Game::bmpBuffer, *main_menu_fnt_credits, SMWX2_VERSION, BUFFER_W-1, BUFFER_H - alfont_text_height(*main_menu_fnt_credits)*2, makecol(255,255,255), -1);
			 alfont_textout_right_aa_ex(Game::bmpBuffer, *main_menu_fnt_credits, "2004", BUFFER_W-1, BUFFER_H - alfont_text_height(*main_menu_fnt_credits), makecol(255,255,255), -1);
			 
			 // menu
			 rect_trans(Game::bmpBuffer, 99, 135, 122, 70, 0, 90);
			 for(a=0;a<4;a++) alfont_textout_aa_ex(Game::bmpBuffer, *main_menu_fnt_menu, Data::Lang("menu_op" + StringUtils::int2str(a)).c_str(), 116, 137 + alfont_text_height(*main_menu_fnt_menu)*a, makecol(255,255,255), -1);
			 main_menu_star.x = 101;
			 main_menu_star.y = 138 + alfont_text_height(*main_menu_fnt_menu)*option;
			 main_menu_star.RunAnimation();
			 main_menu_star.draw(Game::bmpBuffer);
			 
			 // -- options --
			 // Navigating
			 if(Player1_Control.keypress(K_UP)){ option--; play_sample(Data::sample[1]); }
			 if(Player1_Control.keypress(K_DOWN)){ option++; play_sample(Data::sample[1]); }
			 if(option < 0) option = 3;
			 if(option > 3) option = 0;
			 
			 // User has chosen one
			 if(Player1_Control.keypress(K_FIRE1) || Player1_Control.keypress(K_START)){
				 play_sample(Data::sample[2]);
				 switch(option){
				 case 2: // Options
					 FadeFX::fadeOut(0, 16);
					 main_menu_options();
					 break;
				 case 3: // Quit?
					 quit = main_menu_quit();
					 break;
				 }
			 }
			 
			 Game::events();
		 }
		 if(!quit)
			 Game::render();
	 }
	 // </Menu>
	 
	 main_menu_end();
	 
 }
