/*******************************************************
 *  _____                                              *
 * |  ___|  __    __   _  __  _   __   __   ____       *
 * | |___  |  \  /  | | ||  || | \  \/  /  |__  \      *
 * |___  | |   \/   | | \/  \/ |  \    /      | |      *
 *  ___| | | /\  /\ | |   /\   |  /    \    _/ /_      *
 * |_____| |_||__||_| |__/  \__| /__/\__\  |_____|     *
 *                                                     *
 *******************************************************
 *     (c) Gaming Brasil - 2004                        *
 *     Made by Alexandre Martins (@leX)                *
 *     http://www.gamingbrasil.net                     *
 *******************************************************/
 
#ifndef _INI_H
#define _INI_H

#include <map>
#include <string>
#include <vector>
using namespace std;

class CIni{
private:
	string					sCurrentFile;
	map<string,string>		data;
	
public:
	bool					ReadFile(const string& sFile);
	bool					WriteString(const string& sKey, const string& sValue);
	bool					WriteInt(const string& sKey, const int iValue);
	bool					WriteFloat(const string& sKey, const float fValue);
	int						ReadStringVector(const string& sKey, vector<string>& vVector);
	int						ReadIntVector(const string& sKey, vector<int>& vVector);
	int						ReadFloatVector(const string& sKey, vector<float>& vVector);
	
	inline string			ReadString(const string& sKey){ return data[sKey]; }
	inline int				ReadInt(const string& sKey){ return atoi(ReadString(sKey).c_str()); }
	inline float			ReadFloat(const string& sKey){ return atof(ReadString(sKey).c_str()); }
	inline void				Clear(){ data.clear(); sCurrentFile=""; }
	
	CIni(){}
	CIni(const string& sFile){ ReadFile(sFile); }
	
};

#endif
