/*******************************************************
 *  _____                                              *
 * |  ___|  __    __   _  __  _   __   __   ____       *
 * | |___  |  \  /  | | ||  || | \  \/  /  |__  \      *
 * |___  | |   \/   | | \/  \/ |  \    /      | |      *
 *  ___| | | /\  /\ | |   /\   |  /    \    _/ /_      *
 * |_____| |_||__||_| |__/  \__| /__/\__\  |_____|     *
 *                                                     *
 *******************************************************
 *     (c) Gaming Brasil - 2004                        *
 *     Made by Alexandre Martins (@leX)                *
 *     http://www.gamingbrasil.net                     *
 *******************************************************/
 
 #ifndef _INPUTDEVICE_H
 #define _INPUTDEVICE_H
 
 #include <allegro.h>

 #define K_START			1
 #define K_LEFT				2
 #define K_RIGHT			4
 #define K_UP				8
 #define K_DOWN				16
 #define K_FIRE1			32
 #define K_FIRE2			64
 
 // classes
 class CRunOnce;
 
 // CInputDevice class
 class CInputDevice{
 public:
	 
	 bool				keypress_evbuff[7];
	 bool				bUseJoystick;
	 unsigned short		wFlags;
	 int				iKey_start,
						 iKey_left,
						 iKey_right,
						 iKey_up,
						 iKey_down,
						 iKey_fire1,
						 iKey_fire2;
						 
	 CInputDevice(){
		 bUseJoystick = false;
		 wFlags = 0;
		 set_keys(KEY_ENTER, KEY_LEFT, KEY_RIGHT, KEY_UP, KEY_DOWN, KEY_LSHIFT, KEY_LCONTROL);
		 
		 static int a;
		 for(a=0;a<7;a++)
			 keypress_evbuff[a] = false;
	 }
	 
	 void				poll();
	 void				set_keys(int kStart, int kLeft, int kRight, int kUp, int kDown, int kFire1, int kFire2);
	 bool				keypress(int iKey);
	 
	 inline bool		is_key(int iKey){ return wFlags & iKey ? true : false; }
	 inline bool		is_start(){ return wFlags & K_START ? true : false; }
	 inline bool		is_up(){ return wFlags & K_UP ? true : false; }
	 inline bool		is_down(){ return wFlags & K_DOWN ? true : false; }
	 inline bool		is_left(){ return wFlags & K_LEFT ? true : false; }
	 inline bool		is_right(){ return wFlags & K_RIGHT ? true : false; }
	 inline bool		is_fire1(){ return wFlags & K_FIRE1 ? true : false; }
	 inline bool		is_fire2(){ return wFlags & K_FIRE2 ? true : false; }
	 
	 inline static bool	isJoystickAvailable(){ return bool(num_joysticks); }
	 
 };
 
 extern CInputDevice Player1_Control, Player2_Control;
 
 #endif
