/*******************************************************
 *  _____                                              *
 * |  ___|  __    __   _  __  _   __   __   ____       *
 * | |___  |  \  /  | | ||  || | \  \/  /  |__  \      *
 * |___  | |   \/   | | \/  \/ |  \    /      | |      *
 *  ___| | | /\  /\ | |   /\   |  /    \    _/ /_      *
 * |_____| |_||__||_| |__/  \__| /__/\__\  |_____|     *
 *                                                     *
 *******************************************************
 *     (c) Gaming Brasil - 2004                        *
 *     Made by Alexandre Martins (@leX)                *
 *     http://www.gamingbrasil.net                     *
 *******************************************************/
 
#include "StringUtils.h"

// --------------
// Split(): like explode from PHP. Returns the number of terms
// --------------
int StringUtils::Split(const string& input, const string& delimiter, vector<string>& results){
	
  int iPos = 0;
  int newPos = -1;
  int sizeS2 = delimiter.size();
  int isize = input.size();

  vector<int> positions;
  
  newPos = input.find (delimiter, 0);
  results.clear();

  if( newPos < 0 ) { return 0; }

  int numFound = 0;

  while( newPos > iPos )
  {
    numFound++;
    positions.push_back(newPos);
    iPos = newPos;
    newPos = input.find (delimiter, iPos+sizeS2+1);
  }

  for( int i=0; i <= int(positions.size()); i++ )
  {
    string s;
    if( i == 0 ) { s = input.substr( i, positions[i] ); }
    int offset = positions[i-1] + sizeS2;
    if( offset < isize )
    {
      if( i == int(positions.size()) )
      {
        s = input.substr(offset);
      }
      else if( i > 0 )
      {
        s = input.substr( positions[i-1] + sizeS2, 
          positions[i] - positions[i-1] - sizeS2 );
      }
    }
    if( s.size() > 0 )
    {
      results.push_back(s);
    }
  }
  numFound++;
  return numFound;
  
}



// --------------
// Trim(): kinda obvious :P
// --------------
string StringUtils::Trim(string& sText){
	
	char csText[sText.length()+1], csTrimmedText[sText.length()+1];
	string sTrimmedText;
	int a, b;
	bool bQuoted = false;
	
	if(sText.length() == 0) return sText;
	strcpy(csText,sText.c_str());
	
	for(a=0,b=0;a<int(sText.length());a++){
		if(csText[a] == '\"') bQuoted = !bQuoted;
		if(bQuoted || (!isspace(csText[a]) && !bQuoted)){
			csTrimmedText[b] = csText[a];
			csTrimmedText[b+1] = '\0';
			b++;
		}
	}
	
	sTrimmedText = csTrimmedText;
	return sTrimmedText;
	
}


// ------------------------------------
// Chr(ch): transforms a simple character to a string
// ------------------------------------
string StringUtils::Chr(char ch){
	char csCh[2] = {ch, 0};
	string sCh = csCh;
	return sCh;
}


// ------------------------------------
// int2str(x): transforms an int to a string
// ------------------------------------
string StringUtils::int2str(int x, bool hex){
	
	char csString[100];
	
	if(hex)
		sprintf(csString, "%X", x);
	else
		sprintf(csString, "%d", x);
	
	return csString;
	
}


// ------------------------------------
// float2str(x): transforms a float to a string
// ------------------------------------
string StringUtils::float2str(float x){
	
	char csString[100];
	sprintf(csString, "%f", x);
	return csString;
	
}


// ------------------------------------
// Left("string", x): like Left$() from VB
// ------------------------------------
string StringUtils::Left(const string& str, int x){
	
	return str.substr(0, x);
	
}


// ------------------------------------
// Mid("string", x, y): like Mid$() from VB
// ------------------------------------
string StringUtils::Mid(const string& str, int x, int y){
	
	return str.substr(x, y);
	
}


// ------------------------------------
// Right("string", x): like Right$() from VB
// ------------------------------------
string StringUtils::Right(const string& str, int x){
	
	return str.substr(str.length()-x, x);
	
}
