/*******************************************************
 *  _____                                              *
 * |  ___|  __    __   _  __  _   __   __   ____       *
 * | |___  |  \  /  | | ||  || | \  \/  /  |__  \      *
 * |___  | |   \/   | | \/  \/ |  \    /      | |      *
 *  ___| | | /\  /\ | |   /\   |  /    \    _/ /_      *
 * |_____| |_||__||_| |__/  \__| /__/\__\  |_____|     *
 *                                                     *
 *******************************************************
 *     (c) Gaming Brasil - 2004                        *
 *     Made by Alexandre Martins (@leX)                *
 *     http://www.gamingbrasil.net                     *
 *******************************************************/
 
 #include "Timers.h"
 
 // initializing variables
 volatile int Timer::speedcounter = 0;
 volatile int Timer::iFpsCounter = 0;
 volatile int Timer::iFps = 0;
 
 // ---------------------------------------------------
 // setup(): Setups the timer
 // ---------------------------------------------------
 void Timer::setup(){
	 
	 // installing the timers
	 install_timer();
	 
	 // speedcounter timer
	 LOCK_FUNCTION(increment_speedcounter);
	 LOCK_VARIABLE(speedcounter);
	 install_int_ex(increment_speedcounter, BPS_TO_TIMER(60));
	 
	 // FPS
	 LOCK_FUNCTION(fpsCounter_go);
	 LOCK_VARIABLE(iFps);
	 LOCK_VARIABLE(iFpsCounter);
	 install_int(fpsCounter_go, 1000);
	 
 }
