/*******************************************************
 *  _____                                              *
 * |  ___|  __    __   _  __  _   __   __   ____       *
 * | |___  |  \  /  | | ||  || | \  \/  /  |__  \      *
 * |___  | |   \/   | | \/  \/ |  \    /      | |      *
 *  ___| | | /\  /\ | |   /\   |  /    \    _/ /_      *
 * |_____| |_||__||_| |__/  \__| /__/\__\  |_____|     *
 *                                                     *
 *******************************************************
 *     (c) Gaming Brasil - 2004                        *
 *     Made by Alexandre Martins (@leX)                *
 *     http://www.gamingbrasil.net                     *
 *******************************************************/
 
#include "Utils.h"
#include "Game.h"
 
// ------------------------------------------------------------
// DirList(basedir, vector): creates a complete vector
// containing all the directory listing in basedir
// ------------------------------------------------------------
void Utils::DirList(const string& basedir, vector<string>& v){
	
	struct al_ffblk f;
	string chkdir = basedir + "/*";
	
	v.clear();
	
	if(!al_findfirst(chkdir.c_str(), &f, FA_RDONLY | FA_HIDDEN | FA_DIREC)){
		do{
			if(f.name[0] != '.') // avoid "." and ".."
				v.push_back(f.name);
		}while(!al_findnext(&f));
	}
	
	al_findclose(&f);
	
}

// ------------------------------------------------------------
// FileList(basedir, vector): creates a complete vector
// containing all the file listing in basedir
// ------------------------------------------------------------
void Utils::FileList(const string& basedir, vector<string>& v, const string filter){
	
	struct al_ffblk f;
	string chkdir = basedir + "/" + filter;
	
	v.clear();
	
	if(!al_findfirst(chkdir.c_str(), &f, FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_LABEL | FA_ARCH)){
		do{
			if(f.name[0] != '.') // avoid "." and ".."
				v.push_back(f.name);
		}while(!al_findnext(&f));
	}
	
	al_findclose(&f);
	
}
